var lowercase = 'abcdefghijklmnopqrstuvwxyz';
var uppercase = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var numbers = '0123456789';
var all = lowercase + uppercase + numbers;
/**
 * A utility function that generates a strong password
 * @returns
 */
export default function generatePassword() {
    var password = '';
    password += pick(password, lowercase, 1, 5);
    password += pick(password, uppercase, 1, 5);
    password += pick(password, all, 10);
    return shuffle(password);
}
function pick(exclusions, string, min, max) {
    var n, chars = '';
    if (max === undefined) {
        n = min;
    }
    else {
        n = min + Math.floor(Math.random() * (max - min + 1));
    }
    var i = 0;
    while (i < n) {
        var character = string.charAt(Math.floor(Math.random() * string.length));
        if (exclusions.indexOf(character) < 0 && chars.indexOf(character) < 0) {
            chars += character;
            i++;
        }
    }
    return chars;
}
function shuffle(string) {
    var array = string.split('');
    var tmp, current, top = array.length;
    if (top)
        while (--top) {
            current = Math.floor(Math.random() * (top + 1));
            tmp = array[current];
            array[current] = array[top];
            array[top] = tmp;
        }
    return array.join('');
}
